public class Bookshelf {

  private int bsnr;             // numer pi
  private Publication[] pubs;   // tablica publikacji
  private int freeSpace;        // wolne miejcce

  private int currIndex;        // biecy indeks tablicy publikacji,
                                // pod tym indeksem wpiszemy referencj
                                // do publikacji umiesczanej w tablicy


  Bookshelf(int nr, int size) {
    pubs = new Publication[size];
    freeSpace = size;
    bsnr = nr; 
  }

  // Zwraca numer pki
  public int getNr() {
    return bsnr;
  }

  // Umieszcza egzemplarze przekazanej jako argument publikacji
  // na plce. Zwraca true, jeli to si powiodo - w przeciwnym razie false

  public boolean put(Publication p) {

    // jeeli ju na plce - nie robimy nic
    if (p.whereIs() != null) {
      System.out.println("Publikacje ju s na pce");
      return false;
    } 

    int n = p.getQuantity();  // ile egzemplarzy danej pozycji wyd.

    if ( n > freeSpace ) {    // gdy brak wolnego miejsca na pce
      System.out.println("Brak miejsca na pce");
      return false;
    } 

    freeSpace -= n;        // zmniejszenie dostpnego miejsca na pce

    // referencja do obiektu-publikacji jest wpisywana do tablicy publikacji
    // indeks przesuwamy o 1 a nie o n, gdy nie ma sensu powiela 
    // informacji o publikacji dla wszsytkich jej egzemplarzy
   
    pubs[currIndex++] = p;

    // w obiekcie-publikacji zapisujemy referencj do plki na ktrej
    // znalazy si egzemplarze tej publikacji
 
    p.setBookshelf(this);
    return true;
  }

  // zwraca tablic publikacji na pce
  // tablica ta ma currIndex elementw
  // gdy nie powielamy informacji dla > 1 egzemplarzy
  // tej samej publikacji, wobec czego pozostae elementy
  // tablicy publikacji pubs s null i nie uwzgldniamy ich 

  public Publication[] getPubs() { 
    Publication[] p = new Publication[currIndex];
    for (int i=0; i < currIndex; i++) p[i] = pubs[i];
    return p;
  }
}
 