import javax.swing.*;

class NotValidZipException extends Exception {   // Klasa wyjtku

    NotValidZipException() {
      super();
    }

    NotValidZipException(String s)  {                      
      super(s+ "\nPoprawny kod ma posta: nn-nnn"); 
    } 
} 

 
public class ZipAsk {

 public ZipAsk() { }

 public String getZip() throws NotValidZipException { 

    final int N = 6,        // dugo kodu
              P = 2;        // pozycja na ktrej wystpuje kreska

    String zip = JOptionPane.showInputDialog("Podaj kod pocztowy:"); 
    if (zip == null) return zip;

    boolean valid = true;   // czy kod poprawny?

    char[] c = zip.toCharArray(); // tablica znakw w podanym kodzie

    // jeeli struktura wadliwa: nie ta dugo, brak kreski
    if (c.length != N || c[P] != '-') valid = false; 

    // czy w kodzie wystpuj tylko cyfry? 
    for (int i = 0; i<N && valid; i++) { 
         if (i==P) continue; 
         if (!Character.isDigit(c[i])) valid = false; 
         } 
    // w tej chwili wiemy ju, czy kod jest poprawny
    // jeli nie:
    // - tworzymy i zgaszamy wyjtek  
    if (!valid) throw new NotValidZipException("Wadliwy kod: " + zip); 

    // w przeciwnym razie zwracamy kod
    return zip; 
    } 
} 

class ZipAskTest {
 
  public static void main(String[] args) {

    JOptionPane.showMessageDialog(null, "Podaj trzy prawidowe kody pocztowe");

    ZipAsk zask = new ZipAsk();
    String zip = null;
    int n = 3;

    while (n > 0) {
      try {
        zip = zask.getZip();
        if (zip == null) break;
        n--;
      } catch (NotValidZipException exc) {
          JOptionPane.showMessageDialog(null, exc.getMessage());
          continue;
      }
      System.out.println("Kod " + (3-n) + " : " + zip);
    }
    System.exit(0);
 
  } 
 
}
